import { Provide } from '@midwayjs/decorator';
import { InjectEntityModel } from '@midwayjs/typegoose';
import { ReturnModelType } from '@typegoose/typegoose';
import {
  BaseService,
  ServiceError,
  FrameworkErrorEnum,
} from 'free-midway-component';
import { Studio } from '../entity/studio.entity';
import { Types } from 'mongoose';
const ObjectId = Types.ObjectId;
type modelType = ReturnModelType<typeof Studio>;
@Provide()
export class StudioService extends BaseService<modelType> {
  @InjectEntityModel(Studio)
  model: modelType;
  async create(body) {
    const data = await this.model.findOne({ name: body.name });
    if (!data) {
      const res = await this.model.create(body);
      return res;
    }
    throw new ServiceError('工作室名称已被占用', FrameworkErrorEnum.BAD_BODY);
  }
  async update(id, body) {
    const data = await this.model.findOne({ name: body.name });
    if (data) {
      if (String(data._id) === id) {
        return this.model.updateOne({ _id: new ObjectId(id) }, body);
      }
      throw new ServiceError('工作室名称已被占用', FrameworkErrorEnum.BAD_BODY);
    } else {
      return this.model.updateOne({ _id: new ObjectId(id) }, body);
    }
  }
}
